# -*- coding:Utf-8 -*-
import es, gamethread, playerlib, weaponlib, simplemenulib
from dm_python import dm_config, dm_language
from dm_python.dm_config import dmConfig


############################
# FUNCTION
def init():
    es.mexec("dm_python/extension.cfg")
    create()

def create():
    menu = simplemenulib.menu("_dm_python_extension_menu")
    menu.loadlang("cfg/dm_python/language/extension_menu.ini")
    menu.title("extension main title", showpage = False)
    menu.addchoice("extension reload clip", ("extension imputbox reloadclip", dmConfig.reloadclip, "_dp_cvar_reloadclip"))
    menu.subsimplemenu("extension reload clip", "_dm_python_extension_menu")
    menu.addchoice("extension give ammo", ("extension imputbox reloadclip", dmConfig.giveammo, "_dp_cvar_giveammo"))
    menu.subsimplemenu("extension give ammo", "_dm_python_extension_menu")
    menu.simplemenureturn("_dm_python_administration_menu")
    menu.addlist("_dm_python_list_menu")
    menu.blockselect = extension

def extension(userid, index, choice, value, name, page):
    boxmsg, value, command = value
    es.tell(userid, "#multi", dm_language.message(userid, "escmenu imputbox message"))
    es.escinputbox(20, userid, dm_language.message(userid, boxmsg), dm_language.message(userid, "escmenu imputbox currentvalue", {"value" : value}), command)

############################
# EVENT
def load():
    init()

def unload():
    if simplemenulib.exists("_dm_python_extension_menu"): simplemenulib.delete("_dm_python_extension_menu")

def es_map_start(event):
    gamethread.queue(init)

def player_death(event):
    reloadmode = int(dm_config.dmConfig.reloadclip)
    if reloadmode == 1:
        if int(event["headshot"]):
            weapon = weaponlib.getWeapon(event["weapon"])
            if not "#grenade" in weapon.tags: playerlib.getPlayer(event["attacker"]).clip = (weapon.name, weapon.clip)

    elif reloadmode == 2:
        weapon = weaponlib.getWeapon(event["weapon"])
        if not "#grenade" in weapon.tags: playerlib.getPlayer(event["attacker"]).clip = (weapon.name, weapon.clip)

def weapon_fire_on_empty(event):
    if int(dm_config.dmConfig.giveammo) == 1:
        weapon = event["weapon"]
        player = playerlib.getPlayer(event["userid"])
        if not bool(player.getAmmo(weapon)):
            weapon = weaponlib.getWeapon(weapon)
        player.ammo = (weapon.name, weapon.maxammo + weapon.clip)