# -*- coding:Utf-8 -*-
import es, psyco, random, gamethread, weaponlib
psyco.full()

# try to import simplemenulib
try: import simplemenulib
except ImportError: raise ImportError, "dm_python: module simplemenulib is required (http://addons.eventscripts.com/addons/view/simplemenu)"

# if Source Python Extensions is usable, import it...
try:
    from spe.games import cstrike as es_spe
    SourcePythonExtensions = True
except ImportError:
    es.dbgmsg(1, "dm_python: Source Python Extensions is not installed and it will not be used")
    es.dbgmsg(1, "dm_python: you can get this plugin at this following adress http://forums.eventscripts.com/viewtopic.php?t=29657")
    SourcePythonExtensions = False


# if Source Native Tools is usable, import it...
try:
    import nativetools as es_nt
    NativeTools = True
except ImportError:
    es.dbgmsg(1, "dm_python: Native Tools is not installed and it will not be used")
    es.dbgmsg(1, "dm_python: you can get this plugin at this following adress http://forums.eventscripts.com/viewtopic.php?t=32582")
    NativeTools = False

# import modules of dm_python script and associated objects
import dm_player, dm_config, dm_weapon, dm_spawns, dm_votemap, dm_language, dm_usermenu, dm_adminmenu
from dm_config import dmConfig
from dm_weapon import dmWeapon
from dm_spawns import dmSpawns
from dm_votemap import dmVotemap


esInfo = es.AddonInfo()
esInfo.author = "DoCky"
esInfo.version = "2.309p"
esInfo.date = "2010/09/23"
esInfo.basename = "dm_python"
esInfo.name = "Deathmatch Python"
esInfo.url = "http://addons.eventscripts.com/addons/user/11751"

version = es.ServerVar("dm_python", "", " Created by DoCky -")
version.set(esInfo.version)
version.makepublic()
playerdrop = []

############################
# DmPythonError
class DmPythonError(Exception): pass


############################
# FUNCTION
""" initialization """
def init():
    global playerdrop
    playerdrop = []

    dmConfig.update()
    dmSpawns.search(True)
    dmVotemap.newmap()
    dmWeapon.order()
    dmWeapon.read()

    dm_language.load()
    dm_usermenu.create()
    dm_adminmenu.create()

    gamethread.queue(removeObjectives)
    for userid in es.getUseridList():
        player = dm_player.player(userid)
        if es.getplayerteam(userid) > 1: gamethread.queue(player.respawn)

""" remove objectives """
def removeObjectives():
    userid = es.getuserid()
    if userid:
        es.server.queuecmd(
            "es_xfire %s func_hostage_* kill;" % userid +
            "es_xfire %s func_bomb_* kill;" % userid +
            "es_xfire %s func_buyzone kill;" % userid +
            "es_xfire %s hostage_entity kill;" % userid +
            "es_xfire %s weapon_c4 kill" % userid)

""" remove command """
def cmdRemoveWeaponsAndItem():
    gamethread.queue(removeWeaponsAndItems, int(es.getargv(1)))

""" remove weapons and items """
def removeWeaponsAndItems(fromdrop = False):
    userid = es.getuserid()
    if userid:
        entities = es.createentitylist()
        for index in entities:
            classname = entities[index]["classname"]
            if classname.startswith("weapon_") or classname.startswith("item_"):
                if es.getindexprop(index, "CBaseEntity.m_hOwnerEntity") == -1:
                    es.server.queuecmd("es_xsetentityname %s _dm_python_weapons_and_items_at_ground_to_kill_" % index)

        if not fromdrop: es.server.queuecmd("es_xfire %s _dm_python_weapons_and_items_at_ground_to_kill_ kill" % userid)
        else: es.server.queuecmd(
            "es_xcreateentity env_entity_dissolver _dm_python_weapons_and_items_dissolver;" +
            "es_entitysetvalue server_var(eventscripts_lastgive) dissolvetype %s;" % random.randint(0,3) +
            "es_entitysetvalue server_var(eventscripts_lastgive) target _dm_python_weapons_and_items_at_ground_to_kill_;" +
            "es_entitysetvalue server_var(eventscripts_lastgive) magnitude 100;" +
            "es_xfire %s _dm_python_weapons_and_items_dissolver dissolve;" % userid +
            "es_xfire %s _dm_python_weapons_and_items_dissolver kill" % userid)

""" check if player has respawned """
def playerRespawned():
    userid = es.getargv(1)
    if es.getplayerprop(userid, "CBasePlayer.pl.deadflag"):
        raise dm_python.DmPythonError, 'dm_python: respawning of userid "%s" failed' % userid
    dm_player.player(userid).setpos()

""" intercept drop client command """
def playerDrop(userid, arguments):
    if arguments[0].lower() == "drop":
        if not userid in playerdrop:
            playerdrop.append(userid)
            es.server._dp_remove_weapons_and_items(1)
            gamethread.delayedname(1, "_dm_python_player_drop_something_" + str(userid), playerdrop.remove, userid)
            return True
        return False
    return True

""" menu command """
def deathmatchMenu():
    userid = es.getcmduserid()
    if not es.getplayerprop(userid, "CBasePlayer.pl.deadflag"):
        menu = simplemenulib.active(userid)["name"]
        if menu in simplemenulib.getlist("_dm_python_list_menu"): es.tell(userid, "#multi", dm_language.message(userid, "deathmatch menu opened"))
        else:
            if int(dmConfig.style) == 1: simplemenulib.send(userid, "_dm_python_categorie_menu")
            elif dmWeapon.secondary: simplemenulib.send(userid, "_dm_python_secondary_menu")
            else: simplemenulib.send(userid, "_dm_python_primary_menu")
        dm_player.player(userid).firstspawn = False

""" admin command """
def administrationMenu():
    userid = es.getcmduserid()
    steamid = es.getplayersteamid(userid)
    if steamid in dmConfig:
        menu = simplemenulib.active(userid)["name"]
        if menu in simplemenulib.getlist("_dm_python_list_menu"): es.tell(userid, "#multi", dm_language.message(userid, "deathmatch menu opened"))
        else: dm_adminmenu.administrationUpdate(userid)

""" change convars value """
def cvarValue():
    userid = es.getcmduserid()
    if es.getplayersteamid(userid) in dmConfig:
        value = es.getargv(1)
        if value:

            write, name = False, es.getargv(0).replace("_dp_cvar_", "")
            cvar, values, cfgname = dmConfig[name]
            if isinstance(values, int):
                try:
                    value = int(value)
                    if value >= values:
                        cvar.set(value)
                        dmConfig.saveCfg(cfgname)
                        if name == "timeout":
                            for menu in simplemenulib.getlist("_dm_python_deathmatch_menu"): simplemenulib.find(menu).timeout("view", value)
                    else: es.tell(userid, "#multi", dm_language.message(userid, "escmenu imputbox greaterint", {"value" : "#lightgreen" + str(values)}))
                except ValueError: es.tell(userid, "#multi", dm_language.message(userid, "escmenu imputbox wrongint"))

            elif isinstance(values, tuple):
                if value in values:
                    cvar.set(value)
                    dmConfig.saveCfg(cfgname)
                    if name == "style": dm_usermenu.create()

                    elif name == "extension":
                        menu = simplemenulib.find("_dm_python_administration_menu")
                        if value == "1":
                            menu.modchoice("admin extension option", "admin extension option", underline = True)
                            if not extentionLoaded(): es.load("dm_python/dm_extension")
                        else:
                            menu.modchoice("admin extension option", "admin extension option", underline = False)
                            if extentionLoaded(): es.unload("dm_python/dm_extension")
                        menu.update("#all")

                else: es.tell(userid, "#multi", dm_language.message(userid, "escmenu imputbox wrongvalue", {"values" : "#default|".join(map(lambda value: "#lightgreen" + value, values))}))

            else:
                write = True
                cvar.set(value)
                dmConfig.saveCfg(cfgname)
                if name == "admin" or name == "command": dmConfig.createCmd(name)

def addMap():
    userid = es.getcmduserid()
    if es.getplayersteamid(userid) in dmConfig:
        value = es.getargv(1)
        if value:
            if not es.exists("map", value): es.tell(userid, "#multi", dm_language.message(userid, "deathmatch map invalid", {"mapname" : value}))
            else:
                es.tell(userid, "#multi", dm_language.message(userid, "deathmatch map added", {"mapname" : value}))
                dm_votemap.maplist.addlist(value, False)
                dmVotemap.read()

def extentionLoaded():
    # merci Nicolous...
    basename = "dm_python/dm_extension"["dm_python/dm_extension".rfind("/") + 1:]
    pyname = "%s.%s" % ("dm_python/dm_extension".replace("/","."), basename)
    for addon in es.addons.AddonList:
        if addon.__name__ == pyname: return True
    return False


############################
# EVENT
def load():
    init()
    es.addons.registerClientCommandFilter(playerDrop)
    if not es.exists("command", "_dp_player_respawn"):
        es.regcmd("_dp_player_respawn", "dm_python/playerRespawned", "[dm_python] internal command for check has respawned")
    if not es.exists("command", "_dp_remove_weapons_and_items"):
        es.regcmd("_dp_remove_weapons_and_items", "dm_python/cmdRemoveWeaponsAndItem", "[dm_python] server command for remove weapons and items at ground")

    es.regclientcmd("_dp_cvar_admin", "dm_python/cvarValue", "[dm_python] internal command for in-game configuration")
    es.regclientcmd("_dp_cvar_command", "dm_python/cvarValue", "[dm_python] internal command for in-game configuration")
    es.regclientcmd("_dp_cvar_style", "dm_python/cvarValue", "[dm_python] internal command for in-game configuration")
    es.regclientcmd("_dp_cvar_timeout", "dm_python/cvarValue", "[dm_python] internal command for in-game configuration")
    es.regclientcmd("_dp_cvar_plugin", "dm_python/cvarValue", "[dm_python] internal command for in-game configuration")
    es.regclientcmd("_dp_cvar_protection", "dm_python/cvarValue", "[dm_python] internal command for in-game configuration")
    es.regclientcmd("_dp_cvar_random", "dm_python/cvarValue", "[dm_python] internal command for in-game configuration")
    es.regclientcmd("_dp_cvar_respawn", "dm_python/cvarValue", "[dm_python] internal command for in-game configuration")
    es.regclientcmd("_dp_cvar_dissolver", "dm_python/cvarValue", "[dm_python] internal command for in-game configuration")
    es.regclientcmd("_dp_cvar_extension", "dm_python/cvarValue", "[dm_python] internal command for in-game configuration")

    es.regclientcmd("_dp_cvar_assaultsuit", "dm_python/cvarValue", "[dm_python] internal command for in-game configuration")
    es.regclientcmd("_dp_cvar_nightvision", "dm_python/cvarValue", "[dm_python] internal command for in-game configuration")
    es.regclientcmd("_dp_cvar_hegrenade", "dm_python/cvarValue", "[dm_python] internal command for in-game configuration")
    es.regclientcmd("_dp_cvar_flashbang", "dm_python/cvarValue", "[dm_python] internal command for in-game configuration")
    es.regclientcmd("_dp_cvar_smokegrenade", "dm_python/cvarValue", "[dm_python] internal command for in-game configuration")

    es.regclientcmd("_dp_cvar_kills", "dm_python/cvarValue", "[dm_python] internal command for in-game configuration")
    es.regclientcmd("_dp_cvar_time", "dm_python/cvarValue", "[dm_python] internal command for in-game configuration")
    es.regclientcmd("_dp_cvar_maxmap", "dm_python/cvarValue", "[dm_python] internal command for in-game configuration")
    es.regclientcmd("_dp_cvar_lastmaps", "dm_python/cvarValue", "[dm_python] internal command for in-game configuration")
    es.regclientcmd("_dp_add_mapname", "dm_python/addMap", "[dm_python] internal command for in-game configuration")

    es.regclientcmd("_dp_cvar_reloadclip", "dm_python/cvarValue", "[dm_python] internal command for in-game configuration")
    es.regclientcmd("_dp_cvar_giveammo", "dm_python/cvarValue", "[dm_python] internal command for in-game configuration")

def unload():
    dmSpawns.save()
    dm_player.unload()
    dmConfig.deleteCmd()
    simplemenulib.dellist("_dm_python_list_menu")
    if extentionLoaded(): es.unload("dm_python/dm_extension")

    es.addons.unregisterClientCommandFilter(playerDrop)
    gamethread.cancelDelayed("_dm_python_remove_weapons_and_items")
    for userid in playerdrop: gamethread.cancelDelayed("_dm_python_player_drop_something_" + str(userid))

    es.unregclientcmd("_dp_cvar_admin")
    es.unregclientcmd("_dp_cvar_command")
    es.unregclientcmd("_dp_cvar_style")
    es.unregclientcmd("_dp_cvar_timeout")
    es.unregclientcmd("_dp_cvar_plugin")
    es.unregclientcmd("_dp_cvar_protection")
    es.unregclientcmd("_dp_cvar_random")
    es.unregclientcmd("_dp_cvar_respawn")
    es.unregclientcmd("_dp_cvar_dissolver")
    es.unregclientcmd("_dp_cvar_extension")

    es.unregclientcmd("_dp_cvar_assaultsuit")
    es.unregclientcmd("_dp_cvar_nightvision")
    es.unregclientcmd("_dp_cvar_hegrenade")
    es.unregclientcmd("_dp_cvar_flashbang")
    es.unregclientcmd("_dp_cvar_smokegrenade")

    es.unregclientcmd("_dp_cvar_kills")
    es.unregclientcmd("_dp_cvar_time")
    es.unregclientcmd("_dp_cvar_maxmap")
    es.unregclientcmd("_dp_cvar_lastmaps")
    es.unregclientcmd("_dp_add_mapname")

    es.unregclientcmd("_dp_cvar_reloadclip")
    es.unregclientcmd("_dp_cvar_giveammo")

def es_map_start(event):
    dmConfig.saveCfg()
    dmSpawns.save()
    init()

def round_end(event):
    if event["reason"] == "16": dmVotemap.islauched = False

def round_start(event):
    removeObjectives()

def player_disconnect(event):
    userid = event["userid"]
    try: del dm_player.dmPlayer[int(userid)]
    except KeyError: es.dbgmsg(2, 'dm_python: userid "%s" was not registered' % event["userid"])
    try:
        playerdrop.remove(userid)
        gamethread.cancelDelayed("_dm_python_player_drop_something_" + userid)
    except ValueError: es.dbgmsg(2, 'dm_python: userid "%s" was not in playerdrop list' % event["userid"])

def player_team(event):
    if int(event["team"]) > 1: gamethread.delayed(2, dm_player.player(event["userid"]).respawn)

def player_spawn(event):
    userid = int(event["userid"])
    if not es.getplayerprop(userid, "CBasePlayer.pl.deadflag"):
        player = dm_player.player(userid)
        gamethread.queue(player.spawn, event["es_userteam"])

        if simplemenulib.isqueued(userid, "_dm_python_administration_menu", 1): dm_adminmenu.administrationUpdate(userid)
        elif simplemenulib.isqueued(userid, "_dm_python_spawnpoint_menu", 1): dm_adminmenu.spawnpointUpdate(userid, update = True, page = 1)
        elif simplemenulib.isqueued(userid, "_dm_python_spawnpoint_menu", 2): dm_adminmenu.spawnpointUpdate(userid, update = True, page = 2)
        elif player.firstspawn:
            menu = simplemenulib.active(userid)["name"]
            if not menu in simplemenulib.getlist("_dm_python_list_menu"):
                if int(dmConfig.style) == 1: simplemenulib.send(userid, "_dm_python_categorie_menu")
                elif dmWeapon.secondary: simplemenulib.send(userid, "_dm_python_secondary_menu")
                else: simplemenulib.send(userid, "_dm_python_primary_menu")
            player.firstspawn = False

def player_death(event):
    userid = event["userid"]
    time = int(dmConfig.respawn)
    player = dm_player.player(userid)
    try: dmVotemap.check(int(event["es_attackerkills"]) + 1)
    except ValueError: pass

    if int(dmConfig.dissolver): es.server.queuecmd("es_xfire %s %s dissolve" % (userid, player.dissolverRagDoll))
    else: es.server.queuecmd("es_xfire %s cs_ragdoll kill" % userid)
    gamethread.delayed(.1, player.remove)
    gamethread.delayed(time if time > 0 else 1, player.respawn)

    if simplemenulib.isqueued(userid, "_dm_python_administration_menu", 1): dm_adminmenu.administrationUpdate(userid)
    elif simplemenulib.isqueued(userid, "_dm_python_spawnpoint_menu", 1):
        es.tell(userid, "#multi", dm_language.message(userid, "admin alive message"))
        dm_adminmenu.spawnpointUpdate(userid, update = True)

def item_pickup(event):
    userid, item = event["userid"], event["item"]
    if not item in "knifec4":
        if not item in dmWeapon:
            itemInfo = weaponlib.getWeapon(item)
            if itemInfo is not None:
                es.server.queuecmd("es_xfire %s %s kill" % (userid, itemInfo.name))
                es.tell(userid, "#multi", dm_language.message(userid, "deathmatch restricted weapon", {"weapon" : item}))

def hegrenade_detonate(event):
    dm_player.player(event["userid"]).grenade("he")

def flashbang_detonate(event):
    dm_player.player(event["userid"]).grenade("fb")

def smokegrenade_detonate(event):
    dm_player.player(event["userid"]).grenade("sg")
